#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <sys/wait.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>

#define MY_ADDRESS	"/home/knoppix/s1"

void sig_handler(int sig)
{
	while(waitpid(-1, NULL, WNOHANG) > 0)
		;
}

void server(int svr_fd, int cli_fd);

int main()
{
	int svr_fd;
	int cli_fd;
	struct sockaddr_un address;
	socklen_t address_len = sizeof(address);

	signal(SIGCHLD, sig_handler);
	
	svr_fd = socket(PF_UNIX, SOCK_STREAM, 0);
	if(svr_fd < 0)
	{
		printf("Unable to create server socket\n");
		return -1;
	}

	unlink(MY_ADDRESS); /* cancella il file */

	address.sun_family = AF_UNIX;
	strcpy(address.sun_path, MY_ADDRESS);

	if(bind(svr_fd, (struct sockaddr*)&address, address_len) < 0)
	{
		printf("Unable to bind server socket\n");
		return -2;
	}

	if(listen(svr_fd, 5) < 0)
	{
		printf("Unable to listen on server socket\n");
		return -3;
	}
		
	for(;;)
	{
		cli_fd = accept(svr_fd, (struct sockaddr*)&address, &address_len);
		if(cli_fd < 0)
		{
			printf("accept failed\n");
			return -4;
		}
		
		server(svr_fd, cli_fd);
		
		close(cli_fd);
	}
}

void server(int svr_fd, int cli_fd)
{
	time_t now;
	char* today;

	if(fork() == 0)
	{
		close(svr_fd);
		now = time(NULL);
		today = ctime(&now);

		/* partial write not handled */
		write(cli_fd, today, strlen(today));
		close(cli_fd);
		exit(0);
	}
}
